
#include <LiquidCrystal.h>

// constants won't change. They're used here to set pin numbers:
const int buttonPin10 = 2;// the number of the pushbutton pin
const int buttonPin1 = 3;
const int buttonPinN1 = 4;
const int buttonPinN10 = 5;

const int buttonEnter = 6;

const int CtrlPompe = 7;


const int TRUE = 1;
const int FALSE = 0;

const int rs = 13, en = 12, d4 = 11, d5 = 10, d6 = 9, d7 = 8;

LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

// variables will change:
int buttonState10 = 0;         // variable for reading the pushbutton status
int buttonState1 = 0;
int buttonStateN1 = 0;
int buttonStateN10 = 0;

int buttonStateEnter = 0;
int buttonStateReset = 0;

int flag = 0;
int bpm = 1;
double temps = 0;
void setup() {
  // initialises lcd
  lcd.begin(16, 2);

  lcd.print("BPM : ");
  lcd.setCursor(0,1);
  lcd.print(bpm);
  // initialize the pushbutton pin as an input:
  pinMode(buttonPin10, INPUT);
  pinMode(buttonPin1, INPUT);
  pinMode(buttonPinN1, INPUT);
  pinMode(buttonPinN10, INPUT);

  pinMode(buttonEnter, INPUT);


  pinMode(CtrlPompe, OUTPUT);

  Serial.begin(9600);
}
void loop() {

  digitalWrite(CtrlPompe, HIGH);
  lcd.setCursor(0,1);
  flag = FALSE;
  do
  {
    // read the state of the pushbutton value:
    buttonState10 = digitalRead(buttonPin10);
    buttonState1 = digitalRead(buttonPin1);
    buttonStateN1 = digitalRead(buttonPinN1);
    buttonStateN10 = digitalRead(buttonPinN10);

    buttonStateEnter = digitalRead(buttonEnter);
    // check if the pushbutton is pressed. If it is, the buttonState is HIGH:

    if (buttonState10 == HIGH)
    {
      // turn LED on:
      bpm = bpm + 10;
      Serial.println(bpm);
      lcd.print("            ");
      lcd.setCursor(0,1);
      lcd.print(bpm);
      lcd.setCursor(0,1);
    }

    if (buttonState1 == HIGH)
    {
      // turn LED on:
      bpm = bpm + 1;
      Serial.println(bpm);
      lcd.print("            ");
      lcd.setCursor(0,1);
      lcd.print(bpm);
      lcd.setCursor(0,1);
    }

    if (buttonStateN1 == HIGH)
    {
      // turn LED on:
      bpm = bpm - 1;
      Serial.println(bpm);
      lcd.print("            ");
      lcd.setCursor(0,1);
      lcd.print(bpm);
      lcd.setCursor(0,1);
    }

    if (buttonStateN10 == HIGH)
    {
      // turn LED on:
      bpm = bpm - 10;
      Serial.println(bpm);
      lcd.print("            ");
      lcd.setCursor(0,1);
      lcd.print(bpm);
      lcd.setCursor(0,1);
    }

    if (buttonStateEnter == HIGH)
    {
      // turn LED on:
      flag = TRUE;
      Serial.print("Enter| BPM = ");
      Serial.println(bpm);
      lcd.print("            ");
      lcd.setCursor(0,1);
      lcd.print("Enter");
      lcd.setCursor(0,1);
    }

    delay(200);
  } while (flag == FALSE);

  flag = FALSE;

  lcd.setCursor(0,1);

  Serial.print("BPM CTRL = ");
  Serial.println(bpm);

  do
  {
    buttonStateReset = digitalRead(buttonPin10);
    //vérifie pour le reset
  
    //pompe
    digitalWrite(CtrlPompe, LOW);   

    delay(150);               
    
    if (buttonStateReset == HIGH)
    {
      flag = TRUE;
      Serial.print("reset");
      lcd.print("            ");
      lcd.setCursor(0,1);
      lcd.print("Reset");
      lcd.setCursor(0,1);
    }
     temps=60.0/bpm;
     temps=temps-0.15;
     temps=1000*temps;
     Serial.println(temps);
    digitalWrite(CtrlPompe, HIGH);    
    delay(temps);
  } while (flag == FALSE);
}
